searchData={"items":[{"type":"module","title":"HTTPX","doc":"Simple HTTP(s) client with integrated auth methods.","ref":"HTTPX.html"},{"type":"function","title":"HTTPX.delete/2","doc":"Performs a delete request.\n\nFor options see: `&request/3`.","ref":"HTTPX.html#delete/2"},{"type":"function","title":"HTTPX.delete!/2","doc":"Performs a delete request.\n\nFor options see: `&delete/2`.","ref":"HTTPX.html#delete!/2"},{"type":"function","title":"HTTPX.get/2","doc":"Performs a get request.\n\nFor options see: `&request/3`.","ref":"HTTPX.html#get/2"},{"type":"function","title":"HTTPX.get!/2","doc":"Performs a get request.\n\nFor options see: `&get/2`.","ref":"HTTPX.html#get!/2"},{"type":"function","title":"HTTPX.multi_request/3","doc":"Performs a request on all IPs associated with the host DNS.\n\nFor more information see: `request/3`.","ref":"HTTPX.html#multi_request/3"},{"type":"function","title":"HTTPX.optimize/0","doc":"Optimize HTTPX processors.\n\nThis is automatically called on HTTPX load.\nSo there is no need to call it manually.\n\nThe function is idempotent, so there is no harm in calling it.","ref":"HTTPX.html#optimize/0"},{"type":"function","title":"HTTPX.patch/3","doc":"Performs a patch request, passing the body in the options.\n\nFor options see: `&request/3`.","ref":"HTTPX.html#patch/3"},{"type":"function","title":"HTTPX.patch!/3","doc":"Performs a patch request, passing the body in the options.\n\nFor options see: `&patch/3`.","ref":"HTTPX.html#patch!/3"},{"type":"function","title":"HTTPX.perform/1","doc":"Perform a given request.","ref":"HTTPX.html#perform/1"},{"type":"function","title":"HTTPX.post/3","doc":"Performs a post request, passing the body in the options.\n\nFor options see: `&request/3`.","ref":"HTTPX.html#post/3"},{"type":"function","title":"HTTPX.post!/3","doc":"Performs a post request, passing the body in the options.\n\nFor options see: `&post/3`.","ref":"HTTPX.html#post!/3"},{"type":"function","title":"HTTPX.put/3","doc":"Performs a put request, passing the body in the options.\n\nFor options see: `&request/3`.","ref":"HTTPX.html#put/3"},{"type":"function","title":"HTTPX.put!/3","doc":"Performs a post request, passing the body in the options.\n\nFor options see: `&put/3`.","ref":"HTTPX.html#put!/3"},{"type":"function","title":"HTTPX.query_encode/1","doc":"Encode a map as query.","ref":"HTTPX.html#query_encode/1"},{"type":"function","title":"HTTPX.request/3","doc":"Performs a request.\n\nThe given `method` is used and the `url` is called.\n\nThe following options can be set:\n\n  * `:body`, the body to send with the request.\n  * `:params`, a map containing query params.\n  * `:headers`, list of header tuples.\n  * `:settings`, options to pass along to `:hackney`.\n  * `:fail`, will error out any request with a non 2xx response code, when set to true.\n  * `:auth`, set authorization options.\n  * `:format`, set to parse. (Like `:json`)\n  * `:retry`, set to retry the request. See the retry options.","ref":"HTTPX.html#request/3"},{"type":"type","title":"HTTPX.post_body/0","doc":"","ref":"HTTPX.html#t:post_body/0"},{"type":"behaviour","title":"HTTPX.Auth","doc":"Authorization support for HTTP request.\n\nCan be used for basic auth, HMAC auth, etc.","ref":"HTTPX.Auth.html"},{"type":"callback","title":"HTTPX.Auth.auth/2","doc":"Authorizes a HTTP request using the given method, headers, body, and options.","ref":"HTTPX.Auth.html#c:auth/2"},{"type":"module","title":"HTTPX.Log","doc":"Simple logger for HTTPX requests.","ref":"HTTPX.Log.html"},{"type":"macro","title":"HTTPX.Log.log/1","doc":"","ref":"HTTPX.Log.html#log/1"},{"type":"macro","title":"HTTPX.Log.log/4","doc":"","ref":"HTTPX.Log.html#log/4"},{"type":"macro","title":"HTTPX.Log.log/5","doc":"","ref":"HTTPX.Log.html#log/5"},{"type":"module","title":"HTTPX.Process","doc":"HTTPX process module.\n\nApplies all processors to the HTTPX request.","ref":"HTTPX.Process.html"},{"type":"function","title":"HTTPX.Process.optimize/0","doc":"Optimizes the `HTTPX.Process` module, unless `config :httpx, dynamic: true`.\n\nThe optimization involves optimizing the calls to all processors.","ref":"HTTPX.Process.html#optimize/0"},{"type":"function","title":"HTTPX.Process.post_parse/1","doc":"Apply all post parse processors.","ref":"HTTPX.Process.html#post_parse/1"},{"type":"function","title":"HTTPX.Process.post_request/1","doc":"Apply all post request processors.","ref":"HTTPX.Process.html#post_request/1"},{"type":"function","title":"HTTPX.Process.pre_request/1","doc":"Apply all pre request processors.","ref":"HTTPX.Process.html#pre_request/1"},{"type":"behaviour","title":"HTTPX.Processor","doc":"HTTPX processor module.\n\nProcessors allow users to change or update requests,\nduring a request lifetime.\n\nProcessors are applied to all requests by `HTTPX` and\nare an ideal way to insert tracking or metrics.","ref":"HTTPX.Processor.html"},{"type":"behaviour","title":"Configure - HTTPX.Processor","doc":"The processors can be given as a list, which will be applied in order.\n\n```\nconfig :httpx, processors: [Example.Processor]\n```\n\nProcessors will be optimized on startup and can't be dynamically added or removed.\n\nIf such functionality is required, then the following flag needs to be set:\n\n```\nconfig :httpx, dynamic: true\n```","ref":"HTTPX.Processor.html#module-configure"},{"type":"behaviour","title":"Processor Lifetime - HTTPX.Processor","doc":"The lifetime of a processor is:\n`init/1` => `pre_request/2` => `post_request/2` => `post_parse/2`.\n\nThe `init/1`, might be called multiple times,\nbut no more than once per request.","ref":"HTTPX.Processor.html#module-processor-lifetime"},{"type":"behaviour","title":"Hooks - HTTPX.Processor","doc":"Each processor can use the following hooks:\n\n#","ref":"HTTPX.Processor.html#module-hooks"},{"type":"behaviour","title":"init/1 - HTTPX.Processor","doc":"The `init/1` hook is called to let the processor configure itself.\n\nIn the optimized version the `init/1` hook is only called once.\nThe `init/1` can be called once per request,\nwhen `:httpx` is running in dynamic mode.\n\nFor example configuring a tracking header:\n```\n@impl HTTPX.Processor\ndef init(opts) do\n  header = Keyword.get(opts, :tracking_header, \"example\")\n\n  {:ok, %{header: header}}\nend\n```\n\n#","ref":"HTTPX.Processor.html#module-init-1"},{"type":"behaviour","title":"pre_request/2 - HTTPX.Processor","doc":"The `pre_request/2` hook is called before the request is performed.\nIt can be used to change\nor add to the details of a request, before it is\nperformed.\n\nFor example this adds a custom tracking header to all requests:\n```\n@impl HTTPX.Processor\ndef pre_request(req = %{headers: req_headers}, %{header: header}) do\n  {:ok, %{req | headers: [{header, \"...\"} | req_headers]}}\nend\n```\n(Note the `header` comes from the `init/1` above.)\n\n#","ref":"HTTPX.Processor.html#module-pre_request-2"},{"type":"behaviour","title":"post_request/2 - HTTPX.Processor","doc":"The `post_request/2` hook is called after the request is performed,\nbut before the response is parsed.\n\n#","ref":"HTTPX.Processor.html#module-post_request-2"},{"type":"behaviour","title":"post_parse/2 - HTTPX.Processor","doc":"The `post_parse/2` hook is called after the response is parsed.","ref":"HTTPX.Processor.html#module-post_parse-2"},{"type":"behaviour","title":"Example - HTTPX.Processor","doc":"This module will redirect all requests to\n`https://ifconfig.co` and parse only the IP\nin the result.\n\nThis module has no real life use and is just\nan example.\n```\ndefmodule MyProcessor do\n  use HTTPX.Processor\n\n  @impl HTTPX.Processor\n  def pre_request(req, opts) do\n    {:ok, %{req | url: \"https://ifconfig.co\"}}\n  end\n\n  @match ~r/ (.*)<\\/code>/\n\n  @impl HTTPX.Processor\n  def post_parse(%{body: body}, _opts) do\n    case Regex.run(@match, body) do\n      [_, m] -> {:ok, m}\n      _ -> :ok\n    end\n  end\n\n  def post_parse(_, _), do: :ok\nend\n```","ref":"HTTPX.Processor.html#module-example"},{"type":"callback","title":"HTTPX.Processor.__processor__/0","doc":"","ref":"HTTPX.Processor.html#c:__processor__/0"},{"type":"macro","title":"HTTPX.Processor.__using__/1","doc":"HTTPX processor module.\n\nProcessors allow users to change or update requests,\nduring a request lifetime.\n\nProcessors are applied to all requests by `HTTPX` and\nare an ideal way to insert tracking or metrics.","ref":"HTTPX.Processor.html#__using__/1"},{"type":"macro","title":"Configure - HTTPX.Processor.__using__/1","doc":"The processors can be given as a list, which will be applied in order.\n\n```\nconfig :httpx, processors: [Example.Processor]\n```\n\nProcessors will be optimized on startup and can't be dynamically added or removed.\n\nIf such functionality is required, then the following flag needs to be set:\n\n```\nconfig :httpx, dynamic: true\n```","ref":"HTTPX.Processor.html#__using__/1-configure"},{"type":"macro","title":"Processor Lifetime - HTTPX.Processor.__using__/1","doc":"The lifetime of a processor is:\n`init/1` => `pre_request/2` => `post_request/2` => `post_parse/2`.\n\nThe `init/1`, might be called multiple times,\nbut no more than once per request.","ref":"HTTPX.Processor.html#__using__/1-processor-lifetime"},{"type":"macro","title":"Hooks - HTTPX.Processor.__using__/1","doc":"Each processor can use the following hooks:\n\n#","ref":"HTTPX.Processor.html#__using__/1-hooks"},{"type":"macro","title":"init/1 - HTTPX.Processor.__using__/1","doc":"The `init/1` hook is called to let the processor configure itself.\n\nIn the optimized version the `init/1` hook is only called once.\nThe `init/1` can be called once per request,\nwhen `:httpx` is running in dynamic mode.\n\nFor example configuring a tracking header:\n```\n@impl HTTPX.Processor\ndef init(opts) do\n  header = Keyword.get(opts, :tracking_header, \"example\")\n\n  {:ok, %{header: header}}\nend\n```\n\n#","ref":"HTTPX.Processor.html#__using__/1-init-1"},{"type":"macro","title":"pre_request/2 - HTTPX.Processor.__using__/1","doc":"The `pre_request/2` hook is called before the request is performed.\nIt can be used to change\nor add to the details of a request, before it is\nperformed.\n\nFor example this adds a custom tracking header to all requests:\n```\n@impl HTTPX.Processor\ndef pre_request(req = %{headers: req_headers}, %{header: header}) do\n  {:ok, %{req | headers: [{header, \"...\"} | req_headers]}}\nend\n```\n(Note the `header` comes from the `init/1` above.)\n\n#","ref":"HTTPX.Processor.html#__using__/1-pre_request-2"},{"type":"macro","title":"post_request/2 - HTTPX.Processor.__using__/1","doc":"The `post_request/2` hook is called after the request is performed,\nbut before the response is parsed.\n\n#","ref":"HTTPX.Processor.html#__using__/1-post_request-2"},{"type":"macro","title":"post_parse/2 - HTTPX.Processor.__using__/1","doc":"The `post_parse/2` hook is called after the response is parsed.","ref":"HTTPX.Processor.html#__using__/1-post_parse-2"},{"type":"macro","title":"Example - HTTPX.Processor.__using__/1","doc":"This module will redirect all requests to\n`https://ifconfig.co` and parse only the IP\nin the result.\n\nThis module has no real life use and is just\nan example.\n```\ndefmodule MyProcessor do\n  use HTTPX.Processor\n\n  @impl HTTPX.Processor\n  def pre_request(req, opts) do\n    {:ok, %{req | url: \"https://ifconfig.co\"}}\n  end\n\n  @match ~r/ (.*)<\\/code>/\n\n  @impl HTTPX.Processor\n  def post_parse(%{body: body}, _opts) do\n    case Regex.run(@match, body) do\n      [_, m] -> {:ok, m}\n      _ -> :ok\n    end\n  end\n\n  def post_parse(_, _), do: :ok\nend\n```","ref":"HTTPX.Processor.html#__using__/1-example"},{"type":"callback","title":"HTTPX.Processor.init/1","doc":"Initialize processor.","ref":"HTTPX.Processor.html#c:init/1"},{"type":"callback","title":"HTTPX.Processor.post_parse/2","doc":"Post parse processor.","ref":"HTTPX.Processor.html#c:post_parse/2"},{"type":"callback","title":"HTTPX.Processor.post_request/2","doc":"Post request processor.","ref":"HTTPX.Processor.html#c:post_request/2"},{"type":"callback","title":"HTTPX.Processor.pre_request/2","doc":"Pre request processor.","ref":"HTTPX.Processor.html#c:pre_request/2"},{"type":"module","title":"HTTPX.Request","doc":"A prepared HTTP request.\n\nCan be modified by processors and replayed multiple times.","ref":"HTTPX.Request.html"},{"type":"function","title":"HTTPX.Request.prepare/3","doc":"Prepare a request.","ref":"HTTPX.Request.html#prepare/3"},{"type":"type","title":"HTTPX.Request.t/0","doc":"A prepared HTTP request.\n\nCan be modified by processors and replayed multiple times.","ref":"HTTPX.Request.html#t:t/0"},{"type":"module","title":"HTTPX.Response","doc":"HTTP response.","ref":"HTTPX.Response.html"},{"type":"type","title":"HTTPX.Response.t/0","doc":"HTTP response.","ref":"HTTPX.Response.html#t:t/0"},{"type":"exception","title":"HTTPX.RequestError","doc":"HTTPX request error.","ref":"HTTPX.RequestError.html"},{"type":"function","title":"HTTPX.RequestError.exception/3","doc":"HTTPX request error.","ref":"HTTPX.RequestError.html#exception/3"},{"type":"function","title":"HTTPX.RequestError.message/1","doc":"Print a HTTPX request exception","ref":"HTTPX.RequestError.html#message/1"},{"type":"type","title":"HTTPX.RequestError.t/0","doc":"HTTPX request error.","ref":"HTTPX.RequestError.html#t:t/0"},{"type":"extras","title":"HTTPX","doc":"# HTTPX\n\n[![Hex.pm](https://img.shields.io/hexpm/v/httpx.svg \"Hex\")](https://hex.pm/packages/httpx)\n[![Build Status](https://travis-ci.org/IanLuites/httpx.svg?branch=master)](https://travis-ci.org/IanLuites/httpx)\n[![Coverage Status](https://coveralls.io/repos/github/IanLuites/httpx/badge.svg?branch=master)](https://coveralls.io/github/IanLuites/httpx?branch=master)\n[![Hex.pm](https://img.shields.io/hexpm/l/httpx.svg \"License\")](LICENSE)\n\n\nElixir HTTP client with plug like processors.","ref":"readme.html"},{"type":"extras","title":"Quick Setup - HTTPX","doc":"```elixir\n> HTTPX.get(\"http://ifconfig.co\", headers: [{\"user-agent\", \"curl\"}])\n{:ok,\n %HTTPX.Response{\n   body: \"91.181.146.99\\n\",\n   headers: [\n     {\"Date\", \"Sun, 28 Apr 2019 07:08:25 GMT\"},\n     {\"Content-Type\", \"text/plain; charset=utf-8\"},\n     {\"Content-Length\", \"14\"},\n     {\"Connection\", \"keep-alive\"},\n     {\"Set-Cookie\",\n      \"__cfduid=...; expires=Mon, 27-Apr-20 07:08:25 GMT; path=/; domain=.ifconfig.co; HttpOnly\"},\n     {\"Via\", \"1.1 vegur\"},\n     {\"Expect-CT\",\n      \"max-age=604800, report-uri=\\\"https://report-uri.cloudflare.com/cdn-cgi/beacon/expect-ct\\\"\"},\n     {\"Server\", \"cloudflare\"},\n     {\"CF-RAY\", \"...-LHR\"}\n   ],\n   status: 200\n }}\n```","ref":"readme.html#quick-setup"},{"type":"extras","title":"Installation - HTTPX","doc":"The package can be installed\nby adding `httpx` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [{:httpx, \"~> 0.1.0\"}]\nend\n```\n\nThe docs can\nbe found at [https://hexdocs.pm/httpx](https://hexdocs.pm/httpx).","ref":"readme.html#installation"},{"type":"extras","title":"Settings - HTTPX","doc":"#","ref":"readme.html#settings"},{"type":"extras","title":"Pool - HTTPX","doc":"HTTPX will by default use a connection pool named `:default`\nto reuse connections.\n\nSometimes reusing connections can lead to unexpected results,\ntherefore it is possible to disable to the default pool by setting:\n\n```elixir\nconfig :httpx, default_pool: false\n```\n\nIt is also possible to chang the default pool name by setting:\n\n```elixir\nconfig :httpx, default_pool: :custom_pool_name\n```\n_(Note: the name needs to be an atom.)_\n\n#","ref":"readme.html#pool"},{"type":"extras","title":"SSL / TLS - HTTPX","doc":"SSL options can be passed as `:ssl_options`.\n\nCertificate validation is always performed with the CA bundle adapted from Mozilla by https://certifi.io  in the [certifi](https://hex.pm/packages/certifi) package.\n\nBy default certificates are verified to a a depth of level 2, which means the path can be PEER, CA, CA, ROOT-CA, and so on.\n\nTo disable verification pass `verify: :verify_none`.\n\nFor more options see\n[Erlang SSL Options (COMMON)](http://erlang.org/doc/man/ssl.html#TLS/DTLS%20OPTION%20DESCRIPTIONS%20-%20COMMON%20for%20SERVER%20and%20CLIENT)\nand\n[Erlang SSL Options (CLIENT)](http://erlang.org/doc/man/ssl.html#TLS/DTLS%20OPTION%20DESCRIPTIONS%20-%20CLIENT)\ndocumentation.","ref":"readme.html#ssl-tls"},{"type":"extras","title":"Logging - HTTPX","doc":"","ref":"readme.html#logging"},{"type":"extras","title":"Processors - HTTPX","doc":"Processors allow users to change or update requests,\nduring a request lifetime.\n\nProcessors are applied to all requests by `HTTPX` and\nare an ideal way to insert tracking or metrics.\n\n#","ref":"readme.html#processors"},{"type":"extras","title":"Configure - HTTPX","doc":"The processors can be given as a list, which will be applied in order.\n\n```\nconfig :httpx, processors: [Example.Processor]\n```\n\nProcessors will be optimized on startup and can't be dynamically added or removed.\n\nIf such functionality is required, then the following flag needs to be set:\n\n```\nconfig :httpx, dynamic: true\n```\n\n#","ref":"readme.html#configure"},{"type":"extras","title":"Processor Lifetime - HTTPX","doc":"The lifetime of a processor is:\n`init/1` => `pre_request/2` => `post_request/2` => `post_parse/2`.\n\nThe `init/1`, might be called multiple times,\nbut no more than once per request.\n\n#","ref":"readme.html#processor-lifetime"},{"type":"extras","title":"Hooks - HTTPX","doc":"Each processor can use the following hooks:\n\n##","ref":"readme.html#hooks"},{"type":"extras","title":"init/1 - HTTPX","doc":"The `init/1` hook is called to let the processor configure itself.\n\nIn the optimized version the `init/1` hook is only called once.\nThe `init/1` can be called once per request,\nwhen `:httpx` is running in dynamic mode.\n\nFor example configuring a tracking header:\n```\n@impl HTTPX.Processor\ndef init(opts) do\n  header = Keyword.get(opts, :tracking_header, \"example\")\n\n  {:ok, %{header: header}}\nend\n```\n\n##","ref":"readme.html#init-1"},{"type":"extras","title":"pre_request/2 - HTTPX","doc":"The `pre_request/2` hook is called before the request is performed.\nIt can be used to change\nor add to the details of a request, before it is\nperformed.\n\nFor example this adds a custom tracking header to all requests:\n```\n@impl HTTPX.Processor\ndef pre_request(req = %{headers: req_headers}, %{header: header}) do\n  {:ok, %{req | headers: [{header, \"...\"} | req_headers]}}\nend\n```\n(Note the `header` comes from the `init/1` above.)\n\n##","ref":"readme.html#pre_request-2"},{"type":"extras","title":"post_request/2 - HTTPX","doc":"The `post_request/2` hook is called after the request is performed,\nbut before the response is parsed.\n\n##","ref":"readme.html#post_request-2"},{"type":"extras","title":"post_parse/2 - HTTPX","doc":"The `post_parse/2` hook is called after the response is parsed.\n\n#","ref":"readme.html#post_parse-2"},{"type":"extras","title":"Example - HTTPX","doc":"This module will redirect all requests to\n`https://ifconfig.co` and parse only the IP\nin the result.\n\nThis module has no real life use and is just\nan example.\n```\ndefmodule MyProcessor do\n  use HTTPX.Processor\n\n  @impl HTTPX.Processor\n  def pre_request(req, opts) do\n    {:ok, %{req | url: \"https://ifconfig.co\"}}\n  end\n\n  @match ~r/ (.*)<\\/code>/\n\n  @impl HTTPX.Processor\n  def post_parse(%{body: body}, _opts) do\n    case Regex.run(@match, body) do\n      [_, m] -> {:ok, m}\n      _ -> :ok\n    end\n  end\n\n  def post_parse(_, _), do: :ok\nend\n```","ref":"readme.html#example"},{"type":"extras","title":"Streaming - HTTPX","doc":"","ref":"readme.html#streaming"},{"type":"extras","title":"Changelog - HTTPX","doc":"#","ref":"readme.html#changelog"},{"type":"extras","title":"0.1.0 (2020-06-17) - HTTPX","doc":"New features:\n\n* `HTTPX.Request` module to store request information and allow for request replays.\n* `HTTPX.Auth` can now modify more than headers.\n* Processors that allow for modifications to requests on a project/application level.\n* Configure (or disable) the default pool.\n\nChanges:\n\n* `HTTPX.Auth` now applies to a `HTTPX.Request` and not a tuple.\n* `HTTPX.Auth` now returns a [modified] `HTTPX.Request` and not a list of headers.\n* SSL certificates are now verified by default. Use `config :httpx, ssl_verify: false` to disable verification.\n\nOptimizations:\n\n* On load HTTPX optimizes the configured processors.\n\nBug fixes:\n\n* ...","ref":"readme.html#0-1-0-2020-06-17"},{"type":"extras","title":"License - HTTPX","doc":"_HTTPX_ source code is released under [the MIT License](LICENSE).\nCheck [LICENSE](LICENSE) file for more information.","ref":"readme.html#license"}],"content_type":"text/markdown"}